function EFFECT:Init(data)
	
	self.WeaponEnt = data:GetEntity()
	self.Attachment = data:GetAttachment()
	
	self.Position = self:GetTracerShootPos(data:GetOrigin(), self.WeaponEnt, self.Attachment)
	self.Forward = data:GetNormal()
	self.Angle = self.Forward:Angle()
	self.Right = self.Angle:Right()
	self.EndPos = data:GetOrigin()
	self.Norm = ( self.Position - self.EndPos ):Normalize()
	
	local AddVel = self.WeaponEnt:GetOwner():GetVelocity()
	local emitter = ParticleEmitter(self.Position)
	
	self.Dietime = math.Rand( 0.1, 0.15 )
	
	for i = 1, math.random( 3, 6 ) do
		local particle = emitter:Add("particle/particle_smokegrenade", self.Position)
		particle:SetVelocity(60 * i * self.Forward + 1.1 * AddVel)
		particle:SetDieTime(math.Rand(0.36,0.78))
		particle:SetStartAlpha(math.Rand(150,255))
		particle:SetStartSize(math.random(3,4))
		particle:SetEndSize(math.Rand(17,28))
		particle:SetRoll(math.Rand(180,480))
		particle:SetRollDelta(math.Rand(-1,1))
		particle:SetColor(190,190,190)
		particle:SetLighting(true)
		particle:SetAirResistance(150)
    end

	if math.random( 1, 4 ) == 1 then
		/*------- Sparks -----*/
		for i = 1, math.random(3,6) do
			local particle = emitter:Add("effects/yellowflare", self.Position)
			particle:SetVelocity(math.Rand( 50, 250 ) * self.Forward + VectorRand() * math.random(60,120) )
			particle:SetDieTime(math.Rand(0.2, 1))
			particle:SetStartAlpha(255)
			particle:SetStartSize(math.random(1,3))
			particle:SetRoll(0)
			particle:SetGravity(Vector(0, 0, -(math.random(100,400))))
			particle:SetCollide(true)
			particle:SetAirResistance(130)
			particle:SetEndLength(math.Rand(0.1, 0.25))
			particle:SetVelocityScale(true)
			particle:SetCollide(true)
		end
		
		for i = 1, math.random( 4, 10 ) do
	
			local particle = emitter:Add("Effects/spark", self.Position)
		
			particle:SetVelocity(math.Rand( 40, 120 ) * self.Forward + VectorRand() * 20 )
			particle:SetDieTime(math.Rand(0.1, 0.2))
			particle:SetStartAlpha(255)
			particle:SetStartSize(1)
			particle:SetEndSize(0)
			particle:SetRoll(0)
			particle:SetGravity(Vector(0, 0, 0))
			particle:SetCollide(true)
			particle:SetBounce(0.8)
			particle:SetAirResistance(60)
			particle:SetStartLength(0)
			particle:SetEndLength(math.Rand(0.1, 0.25))
			particle:SetVelocityScale(true)
			particle:SetRoll( math.Rand( 0, 1680 ) )
			particle:SetRollDelta( math.Rand( -1, 1 ) )
			particle:SetCollide(true)
		end
		
		for i = 1,math.random(1,3) do 	
			local particle = emitter:Add("Effects/spark", self.Position)
			particle:SetVelocity(math.Rand( 10, 40 ) * self.Forward + VectorRand() * math.random( 10, 30))
			particle:SetDieTime(math.Rand(0.1, 0.4))
			particle:SetStartAlpha(255)
			particle:SetEndAlpha(255)
			particle:SetStartSize(1)
			particle:SetEndSize(0)
			particle:SetRoll(0)
			particle:SetGravity(Vector(0, 0, 0))
			particle:SetCollide(true)
			particle:SetBounce(0.8)
			particle:SetAirResistance(60)
			particle:SetRoll( math.Rand( 120, 460 ) )
			particle:SetRollDelta( math.Rand( -1, 1 ) )
			particle:SetCollide(true)
		end
		
		for i = 1,6 do

			local particle = emitter:Add( "sprites/heatwave", self.Position - self.Forward * 4 )

			particle:SetVelocity( 80 * self.Forward + 20 * VectorRand() + 1.05 * AddVel )
			particle:SetGravity( Vector( 0, 0, 100 ) )
			particle:SetAirResistance( 160 )

			particle:SetDieTime( self.Dietime )

			particle:SetStartSize( math.random( 0.5, 1 ) )
			particle:SetEndSize( math.Rand( 5, 10 ) )

			particle:SetRoll( math.Rand( 180, 480 ) )
			particle:SetRollDelta( math.Rand( -1, 1 ) )
		
			local particle = emitter:Add( "effects/muzzleflash"..math.random( 1, 4 ), self.Position )

			particle:SetVelocity( 50 * i * self.Forward + 8 * VectorRand() + AddVel )
			particle:SetAirResistance( 400 )
			particle:SetGravity( Vector(0, 0, math.Rand(100, 200) ) )
			particle:SetDieTime( self.Dietime )

			particle:SetStartAlpha(  math.Rand( 150, 255 ) )
			particle:SetEndAlpha( 0 )

			particle:SetStartSize( math.Rand( 0.3, 0.8 ) )
			particle:SetEndSize( math.Rand( 5, 15 ) )

			particle:SetRoll( math.Rand( 180, 480 ) )
			particle:SetRollDelta( math.Rand( -1, 1 ) )

			particle:SetColor( 255, 255, 255 )
			
		end
		
		local dlight = DynamicLight(0)
		if (dlight) then
			dlight.Pos 		= self.Position
			dlight.r 		= 70
			dlight.g 		= 50
			dlight.b 		= 0
			dlight.Brightness = 3
			dlight.size 	= 1000
			dlight.Decay = 300
			dlight.DieTime 	= CurTime() + 0.01
		end
				
	end
		
	emitter:Finish()
end

function EFFECT:Think()

	return false
end


function EFFECT:Render()
end